<template>
    <v-container fill-height fluid>
        <v-layout align-center justify-center>
            <v-flex md4 sm8 xs12>
                <v-card class="elevation-12">
                    <v-form @submit.prevent="redirectToProvider">
                        <v-toolbar color="primary" dark>
                            <v-toolbar-title>Sisselogimine</v-toolbar-title>
                            <v-spacer></v-spacer>
                        </v-toolbar>
                        <v-card-text v-if="!isLoading">

                            <v-text-field append-icon="keyboard_arrow_right" label="Ametikooli E-mail"
                                          placeholder="eesnimi.perenimi@ametikool.ee" name="login"
                                          prepend-icon="person" type="text" v-model="email"></v-text-field>
                        </v-card-text>
                        <v-card-text v-else-if="isLoading">
                            <v-progress-linear
                                    indeterminate
                                    color="blue"
                            ></v-progress-linear>
                        </v-card-text>
                        <v-card-actions v-if="!isLoading">
                            <v-spacer></v-spacer>
                            <v-btn type="submit" color="primary">Login</v-btn>
                        </v-card-actions>
                    </v-form>
                </v-card>
            </v-flex>
        </v-layout>
    </v-container>
</template>

<script>
    import axios from "axios";

    export default {
        name: "Login",
        data() {
            return {
                isLoading: false,
                email: ''
            }
        },
        mounted() {
            console.log('LOGIN MOUNTED');
            if (this.$route.query.code !== undefined) {
                this.isLoading = true;

                this.$store.dispatch('AUTH_REQUEST', {code: this.$route.query.code}).then(() => {
                    axios.get(
                        '/api/users/me'
                    )
                        .then(response => response.data)
                        .then(user => {
                            this.$store.commit('SET_USER', user);
                            localStorage.setItem('currentUser', JSON.stringify(user));
                            this.$router.push('/');
                            this.$store.commit('SET_LAYOUT', 'app-layout');
                        });
                })
            }
        },
        methods: {
            redirectToProvider() {
                if(this.email === 'admin@demo.com' || this.email === 'moderator@demo.com' || this.email === 'user@demo.com') {
                    // let demoCode;
                    //
                    // switch (this.email) {
                    // case "admin@demo.com":
                    //     demoCode = "DEMO_ADMIN";
                    //     break;
                    // case "moderator@demo.com":
                    //     demoCode = "DEMO_MODERATOR";
                    //     break;
                    // case "user@demo.com":
                    //     demoCode = "DEMO_USER";
                    //     break;
                    // }

                    this.$store.dispatch('AUTH_REQUEST', {code: this.email}).then(() => {
                        axios.get(
                            '/api/users/me'
                        )
                            .then(response => response.data)
                            .then(user => {
                                this.$store.commit('SET_USER', user);
                                localStorage.setItem('currentUser', JSON.stringify(user));
                                this.$router.push('/');
                                this.$store.commit('SET_LAYOUT', 'app-layout');
                            });
                    });

                    return true;
                }

                window.location = 'https://login.microsoftonline.com/66b93e6b-3bac-45eb-bd8c-91ce24bb1810/oauth2/authorize' +
                    '?client_id=6ad93b3d-3ed4-49b5-ac24-9ddfc3d093f2' +
                    '&response_type=code' +
                    '&redirect_uri=' + window.config.appURL + '/login' +
                    '&response_mode=query' +
                    '&login_hint=' + this.email;
            },
            login() {

            }
        }
    }
</script>

<style scoped>

</style>